import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
import { jsx as _jsx } from "react/jsx-runtime";
import cx from 'classnames';
export var AVATAR_BADGE_STATUSES = {
  ERROR: 'error',
  SUCCESS: 'success'
};
export var AVATAR_BADGE_PLACEMENTS = {
  TOP: 'top',
  BOTTOM: 'bottom'
};
export var AVATAR_BADGE_SIZES = {
  XXLARGE: 'xxlarge',
  XLARGE: 'xlarge',
  LARGE: 'large',
  MEDIUM: 'medium',
  SMALL: 'small',
  XSMALL: 'xsmall'
};

var MoleculeAvatarBadge = function MoleculeAvatarBadge(_ref) {
  var classNameProp = _ref.className,
      size = _ref.size,
      _ref$status = _ref.status,
      status = _ref$status === void 0 ? AVATAR_BADGE_STATUSES.ERROR : _ref$status,
      _ref$placement = _ref.placement,
      placement = _ref$placement === void 0 ? AVATAR_BADGE_PLACEMENTS.BOTTOM : _ref$placement,
      others = _objectWithoutPropertiesLoose(_ref, ["className", "size", "status", "placement"]);

  var baseClassName = 'sui-MoleculeAvatarBadge';
  var className = cx(baseClassName, classNameProp, baseClassName + "--" + size, baseClassName + "--" + status, baseClassName + "--" + placement);
  return /*#__PURE__*/_jsx("div", _extends({
    className: className
  }, others));
};

MoleculeAvatarBadge.displayName = 'MoleculeAvatarBadge';
export default MoleculeAvatarBadge;