import _extends from "@babel/runtime/helpers/esm/extends";
import _objectWithoutPropertiesLoose from "@babel/runtime/helpers/esm/objectWithoutPropertiesLoose";
import { jsxs as _jsxs } from "react/jsx-runtime";
import { Fragment as _Fragment } from "react/jsx-runtime";
import { jsx as _jsx } from "react/jsx-runtime";
import { Children, isValidElement, cloneElement } from 'react';
import cx from 'classnames';
import AtomImage from '@s-ui/react-atom-image';
import AtomSkeleton from '@s-ui/react-atom-skeleton';
import useConvertStringToHex from './useConvertStringToHex';
import AvatarFallback from './AvatarFallback';
import AvatarBadge from './AvatarBadge';
export var AVATAR_SIZES = {
  XXLARGE: 'xxlarge',
  XLARGE: 'xlarge',
  LARGE: 'large',
  MEDIUM: 'medium',
  SMALL: 'small',
  XSMALL: 'xsmall'
};

var MoleculeAvatar = function MoleculeAvatar(_ref) {
  var classNameProp = _ref.className,
      _ref$size = _ref.size,
      size = _ref$size === void 0 ? AVATAR_SIZES.MEDIUM : _ref$size,
      _ref$skeleton = _ref.skeleton,
      skeleton = _ref$skeleton === void 0 ? /*#__PURE__*/_jsx(AtomSkeleton, {
    width: "100%",
    height: "100%",
    animation: "wave"
  }) : _ref$skeleton,
      name = _ref.name,
      src = _ref.src,
      fallbackIcon = _ref.fallbackIcon,
      style = _ref.style,
      isLoading = _ref.isLoading,
      childrenProp = _ref.children,
      others = _objectWithoutPropertiesLoose(_ref, ["className", "size", "skeleton", "name", "src", "fallbackIcon", "style", "isLoading", "children"]);

  var baseClassName = 'sui-MoleculeAvatar';
  var className = cx(baseClassName, baseClassName + "--" + size);
  var backgroundColor = useConvertStringToHex(name);
  var children = Children.toArray(childrenProp).filter(function (child) {
    return /*#__PURE__*/isValidElement(child);
  }).map(function (child) {
    return /*#__PURE__*/cloneElement(child, {
      size: size
    });
  });

  var renderFallback = function renderFallback() {
    return /*#__PURE__*/_jsx(AvatarFallback, {
      name: name,
      size: size,
      icon: fallbackIcon
    });
  };

  var renderContent = function renderContent() {
    if (isLoading) {
      return skeleton;
    }

    return /*#__PURE__*/_jsxs(_Fragment, {
      children: [src ? /*#__PURE__*/_jsx(AtomImage, {
        src: src,
        alt: name,
        errorIcon: renderFallback()
      }) : renderFallback(), !isLoading && children]
    });
  };

  return /*#__PURE__*/_jsx("span", _extends({
    style: _extends({}, style, {
      backgroundColor: backgroundColor
    }),
    className: className
  }, others, {
    children: renderContent()
  }));
};

MoleculeAvatar.displayName = 'MoleculeAvatar';
MoleculeAvatar.Badge = AvatarBadge;
export default MoleculeAvatar;